#pragma once
#include "ConfigValue.h"
#include "../gui/menu/imgui_addons.h"

#pragma pack(push, 1)
class IntSliderEditableValue : public ConfigValue
{
public:
    IntSliderEditableValue(const int initial, const int min, const int slider_max, const std::string& n)
        : ConfigValue(n)
    {
        value_ = initial;
        def_ = initial;
        min_ = min;
        slider_max_ = slider_max;
    }

    void draw() override
    {
        imgui_addons::slider_int_editable(this->get_imgui_title(), &value_, min_, slider_max_, disabled_);
    }

    void set(const std::string& string) override
    {
        value_ = from_string(string);
    }

    std::string get() override
    {
        return to_string(value_);
    }

    std::string get_default() override
    {
        return to_string(def_);
    }

    [[nodiscard]] int get_value() const
    {
        return value_;
    }

private:
    int value_;
    int def_;
    int min_;
    int slider_max_;

    static std::string to_string(const int v)
    {
        return std::to_string(v);
    }

    static int from_string(const std::string& string)
    {
        return std::stoi(string);
    }
};
#pragma pack(pop)